import tensorflow as tf

'''
モデル 簡易GAN
'''

NAME = 'easy_gan'

INPUT_SIZE = 10


def generator(inputs, batch_size, is_train=True):
  with tf.variable_scope('generator'):
    with tf.variable_scope('reshape'):
      fc0 = tf.layers.dense(inputs, 4 * 4 * 36)
      out0 = tf.reshape(fc0, [batch_size, 4, 4, 36])

    with tf.variable_scope('conv_transpose1'):
      out1 = tf.layers.conv2d_transpose(out0, 24, [5, 5], (2, 2))
      print(out1.get_shape())

    with tf.variable_scope('conv_transpose2'):
      out2 = tf.layers.conv2d_transpose(out1, 16, [5, 5], (2, 2))
      print(out2.get_shape())

    with tf.variable_scope('conv_transpose3'):
      out3 = tf.layers.conv2d_transpose(out2, 1, [5, 5], (2, 2))
      print(out3.get_shape())

  return tf.nn.tanh(out3)


def discriminator(inputs, batch_size, is_reuse=False, is_train=True):
  with tf.variable_scope('discriminator'):
    with tf.variable_scope('conv1', reuse=is_reuse):
      conv1 = tf.layers.conv2d(inputs, 16, [5, 5], (2, 2),
                               activation=tf.nn.relu)

    with tf.variable_scope('conv2', reuse=is_reuse):
      conv2 = tf.layers.conv2d(conv1, 24, [5, 5], (2, 2),
                               activation=tf.nn.relu)

    with tf.variable_scope('conv3', reuse=is_reuse):
      conv3 = tf.layers.conv2d(conv2, 36, [5, 5], (2, 2),
                               activation=tf.nn.relu)

    with tf.variable_scope('fully_connected', reuse=is_reuse):
      reshaped = tf.reshape(conv3, [batch_size, -1])
      output = tf.layers.dense(reshaped, 1)

  return output
